stages:
  - clone-specific-commit
  - build-docker-machine
  - build-gitlab-runner

variables:
  # This must match the gitlab-runner docker tag
  RUNNER_VERSION: v11.10.0

clone specific commit:
  stage: clone-specific-commit
  image: docker
  variables:
    GIT_CHECKOUT: "false"
  script:
  - apk add git
  - git clone https://github.com/docker/machine.git dockermachine
  - cd dockermachine
  # Pinning the commit. This is temporary until there is a release with metadata options for openstack driver
  - git checkout 61ef47dc5d6b1658e3d6636f9382d50507c8c7e1
  artifacts:
    paths:
    - dockermachine
    expire_in: 1 week
  
build docker machine: &build_base
  stage: build-docker-machine
  services:
  - docker:dind
  image: docker
  variables:
    USE_CONTAINER: "true"
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay
    GIT_CHECKOUT: "false"
  before_script:
  - apk add -U make bash
  - cd dockermachine
  - export TARGET_OS=$(echo $CI_JOB_NAME | cut -d ' ' -f 1)
  - export TARGET_ARCH=$(echo $CI_JOB_NAME | cut -d ' ' -f 2)
  script:
  - make build validate
  artifacts:
    paths:
    - dockermachine/bin/
    expire_in: 1 week
  tags:
  - docker-privileged

docker:
  stage: build-gitlab-runner
  image: 
    # We recommend using the CERN version of the Kaniko image: gitlab-registry.cern.ch/ci-tools/docker-image-builder
    name: gitlab-registry.cern.ch/ci-tools/docker-image-builder
    entrypoint: [""]
  script:
    # Prepare Kaniko configuration file
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    # Build and push the image from the Dockerfile at the root of the project.
    # To push to a specific docker tag, amend the --destination parameter, e.g. --destination $CI_REGISTRY_IMAGE:$CI_BUILD_REF_NAME
    # See https://docs.gitlab.com/ee/ci/variables/predefined_variables.html#variables-reference for available variables
    - /kaniko/executor --context $CI_PROJECT_DIR --build-arg RUNNER_VERSION=$RUNNER_VERSION --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE:$RUNNER_VERSION
  dependencies: 
    - build docker machine